import os
import json
import random 
import string
import hashlib
class Rootoi:
    def __init__(self,database:str,rc:int):
        self.__rc = rc
        self.__db = database
        self.__VERSION = ['1.0.4']
        self.security = {}
        self.__verification()
    def __verification(self):
        def json_reader(file_path:str) -> bool:
            __file_path = os.path.isfile(file_path) 
            if __file_path:
                with open(file_path,"r") as file:
                    d = json.loads(file.read())
                return d
            else:
                raise FileNotFoundError

        def security_checker(security_config:dict) -> dict:
            pc = {"hashing":True}
            try:
                __encryption = security_config["security"]
            except Exception as e:
                raise KeyError
            try:
                _vi2 = security_config["security"]["hashing"]
            except Exception as e:
                raise KeyError
            try:
                _vi3 = security_config["security"]["config"]
            except Exception as e:
                raise KeyError
            try:
                _vi3o1 = security_config["security"]["config"]["hashing"]
            except Exception as e:
                raise KeyError
            if type(__encryption) == dict:
                if (type(_vi2) == bool and type(_vi3) == dict):
                    if _vi2 == True:
                        if _vi3o1 == "DEFAULT":
                            pass
                        else:
                            raise ValueError
                    else:
                        pc["hashing"] = False
                else:
                    raise ValueError 
            else:
                raise ValueError 
            return pc
        __config = f'{self.__db}.config.json'
        __dbu = f'{self.__db}.rootoi'
        __dc = json_reader(__config)
        if (__dc['dbn'] == __dbu and __dc['version'] == self.__VERSION[self.__VERSION.index(__dc['version'])] and str(__dc['column']) == str(self.__rc)):
            if os.path.isfile(__dbu):
                pass
            else:
                raise FileNotFoundError
            __en = security_checker(__dc)
        else:
            raise ValueError
        __fvc={
            "dbn":__dc['dbn'],
            "version":__dc['version'],
            "hashing": __en['hashing'],
            "column": __dc['column']
        }
        return __fvc
    def create_entry(self,*entry):
        def __idgen():
            j = ''
            data =[random.choice(list(string.ascii_lowercase + string.ascii_uppercase+string.digits)) for i in range(108)]
            for i in data:
                j += i
            return j
        self.db= f"{self.__db}.rootoi"
        self.hstatus = self.__verification()['hashing']
        entry = [str(i) for i in entry]
        print(entry)
        if self.__rc ==len(entry):        
            with open(self.db,"a") as file:
                j = ''
                q = __idgen()
                j+=q + "_"
                j+= str(int(self.hstatus))  + "_"
                if self.hstatus:
                    for i in entry:
                        a = i.replace(" ",'-')
                        j += hashlib.sha256(a.encode()).hexdigest() + "_"
                    j += "\n"
                else:
                    for i in entry:
                        a = i.replace(" ",'-')
                        j += str(a) + "_"
                    j += "\n"
                file.write(j)
            return j
        else:
            raise ValueError
    def read_all_entry(self):
        self.db= f"{self.__db}.rootoi"
        with open(self.db,"r") as f:
            q = [i.strip().split("_") for i in f.readlines()]
            self.data = []
            for i in q:
                i.pop(-1)
                r = i[0]
                i.pop(0)
                i.pop(1)
                self.data.append({r:i})
            return self.data
    def read_entry(self,id):
        self.db= f"{self.__db}.rootoi"
        with open(self.db,"r") as f:
            q = [i.strip().split("_") for i in f.readlines()]
            self.data = None
            flag = False
            for i in q:
                i.pop(-1)
                if id == i[0]:
                    self.data = i[2::]
                    flag = True
            if flag:
                return self.data
            else:
                raise Exception("id not exists")
    def delete_all_entry(self):
        self.db= f"{self.__db}.rootoi"
        with open(self.db,"w") as f:
            f.write("")
    def delete_entry(self,id):
        self.db= f"{self.__db}.rootoi"
        d = []
        with open(self.db,"r") as f:
            q = [i.strip().split("_") for i in f.readlines()]
            flag = False
            for i in q:
                i.pop(-1)
                if id == i[0]:
                    flag = True
                else:
                    c = "_".join(i)
                    c += "_\n"
                    d.append(c)
            d = ''.join(d)
        if flag:
            with open(self.db,"w") as f:
                f.write(d)
        else:
            raise Exception("id not found ")
    def update_entry(self,id:str,column:int,value):
        self.db= f"{self.__db}.rootoi"
        a = value.split(" ")
        l = []
        for i in a :
            if i == '':
                pass
            else:
                l.append(i)
        a = "-".join(l)
        k = []
        with open(self.db,"r") as f:
            q = [i.strip().split("_") for i in f.readlines()]
            flag = False
            for i in q:
                i.pop(-1)
                if id == i[0]:
                    i[2 + column-1] = str(a)
                    flag = True
                else:
                    pass
                c = "_".join(i)
                c += "_\n"
                k.append(c)
        k = "".join(k)
        
        if flag:
            with open(self.db,"w") as f:
                f.write(k)
        else:
            raise Exception("id not found ")
    def hash_dev_sha256(self):
        self.db= f"{self.__db}.rootoi"
        k =''
        with open(self.db,"r") as f:
            q = [i.strip().split("_") for i in f.readlines()]
            self.data = []
            for i in q:
                i.pop(-1)
                if int(i[1]) == 1:
                    a = '_'.join(i)
                    a += "_\n"
                else:
                    a =i[0] +"_"+ str(1)+"_"
                    i  = [hashlib.sha256(j.encode()).hexdigest() for j in i[2::] ]
                    a += '_'.join(i)
                    a += "_\n"
                k+= a
        with open(self.db,"w") as file:
            file.write(k)